unit Pack;

interface
type
  TSuit = (stSpade, stDiamond, stClub, stHeart);
  TValue = (vlTwo, vlThree, vlFour, vlFive, vlSix, vlSeven, vlEight, vlNine, vlTen,
    vlJack, vlQueen, vlKing, vlAce);

  TPokerCard = record
    Suit: TSuit;
    Value: TValue;
    end;

  TPackArray =  array[1..52] of TPokerCard;
  T5CardArray = array[1..5] of TPokerCard;

  TPack = class
  private
    FPackArray: TPackArray;
    FTop: Integer;
    procedure InitCards;
  public
    constructor Create;
    procedure Shuffle;
    function Draw5Cards : T5CardArray;
  end;

implementation
constructor TPack.Create;
begin
  inherited Create;
  InitCards;
end;

procedure TPack.InitCards;
var
  i: Integer;
  AValue: TValue;
  ASuit: TSuit;
begin
  AValue := vlTwo;
  ASuit := stSpade;
  for i := 1 to 52 do
  begin
    FPackArray[i].Value := AValue;
    FPackArray[i].Suit := ASuit;
    if (i mod 4 = 0) and (i <> 52) then
      Inc(AValue);
    if ASuit <> High(TSuit) then
      Inc(ASuit)
    else
      ASuit := Low(TSuit);
  end;
end;

procedure TPack.Shuffle;
var
  Temp: TPokerCard;
  R: Integer;
  i: Integer;
begin
  for i := 1 to 52 do
  begin
    R := Random(52) + 1;     // Random number between 1 and 52
    Temp := FPackArray[R];
    FPackArray[R] := FPackArray[i];
    FPackArray[i] := Temp;
  end;
    FTop := 1;     //  Top of pack
end;

function TPack.Draw5Cards : T5CardArray;
var
  i :  integer;
begin
  for i := 1 to 5 do
  begin
    Result[i] :=  FPackArray[FTop];
    Inc(FTop);
  end;
end;

initialization
   Randomize;
end.
