unit User;

interface
uses
  PokerPlayer;
type
  TUserPlayer = class(TPokerPlayer)
  private
    FAccount: Integer;
    procedure SetAccount(AValue: Integer);
  public
    procedure Bet(AValue: Integer);
    procedure Raize(const Player: TPokerPlayer; AValue: Integer);
    procedure Call(const Player: TPokerPlayer);
    procedure Pass;
    property Account: Integer read FAccount write setAccount;
  end;

implementation

procedure TUserPlayer.SetAccount(AValue: Integer);
{Account = amount user is winning or losing}
begin
  if FAccount <> AValue then
    FAccount := AValue;
end;

procedure TUserPlayer.Raize(const Player: TPokerPlayer; AValue: Integer);
begin
  if not Player.Raized then
    BetValue := Player.BetValue + AValue      // If raising a bet
  else
    BetValue := Player.RaizeValue + AValue;   // If raising a raise
  RaizeValue := AValue;
  Raized := True;
  Dec(Faccount, BetValue);
end;

procedure TUserPlayer.Bet(AValue: Integer);
begin
  BetValue := AValue;
  Dec (Faccount, BetValue);
end;

procedure TUserPlayer.Call(const Player: TPokerPlayer);
begin
  if not Player.Raized then
    BetValue := Player.BetValue
  else
    BetValue := Player.RaizeValue;
  Called := True;
  Dec (Faccount, BetValue);
end;

procedure TUserPlayer.Pass;
begin
  Passed := True;
  BetValue := 0;
end;

end.
